#ifndef __LINKERAPI_H__
#define __LINKERAPI_H__

#define LINKER_API __declspec(dllimport) 

	LINKER_API bool getFwVersion(char * str);
	LINKER_API bool setActivePort(LINKER_INPORT port);
	LINKER_API bool getVideoFormat(LINKER_VIDEOSTATUS *vs);
	LINKER_API bool setAutoSwitch(bool state);
	LINKER_API bool setSwPriority(bool state);
	LINKER_API bool setHdcpVersion(LINKER_HDCP hdcp);
	LINKER_API bool setLogoLed(bool state);
	LINKER_API bool setHtpc(bool state);

	LINKER_API bool setScaling(LINKER_SCALE mode);

	LINKER_API bool setCsc(LINKER_COLFMT mode);
	LINKER_API bool setDownCsc(LINKER_COLFMT mode);
	LINKER_API bool setDeepColor(LINKER_DC mode);
	LINKER_API bool setDsDeepColor(LINKER_DC mode);

	LINKER_API bool setBt2020Force(LINKER_BT2020 state);

	LINKER_API bool setPreset4k30(bool state);
	LINKER_API bool setPreset4k60(bool state);
	LINKER_API bool setPreset4k30Mode(LINKER_PRESET mode);
	LINKER_API bool setPreset4k60Mode(LINKER_PRESET mode);
	LINKER_API bool setIgnoreEdid(bool state);

	LINKER_API bool changeCustomEdid(EDIDTABLE tableIndex);		// choose one of the custom tables (applicable in custom EDID mode)
	LINKER_API bool setCustomEdid(BYTE * EdidBuf);				// upload any table (applicable in custom EDID mode)
	LINKER_API bool setEdidMode(LINKER_EDID mEdid);				// choose automix/fixed/custom EDID mode
	LINKER_API bool getSinkEdid(uint8 *pEdidBuf);				// sink edid read
	LINKER_API bool getEdid(uint8 *pEdidBuf);					// get current active edid 

	LINKER_API bool setHdrIf(char * if_str, bool crc_check);	// Set the custom HDR infoframe
	LINKER_API bool setCustomHdr(bool state);
	LINKER_API bool setHdrDisable(bool state);
	LINKER_API bool setAutoFillCrc(bool State);

	LINKER_API bool setAviIf(char * avi_str);					// set the custom AVI infoframe
	LINKER_API bool setCustomAvi(bool state);
	LINKER_API bool setAviDisable(bool state);

	LINKER_API bool set3x(SB_VALUES  *sb);						// Write coefficients
	LINKER_API bool get3x(SB_VALUES  *sb);						// Get coefficients
	LINKER_API bool set3xEn(bool state);						// Enable/Disable
	LINKER_API bool reset3x(SB_VALUES  *sb);					// Clear values to defaults

	LINKER_API bool setLinkerState(LINKER_CMD cmd, BYTE Value);		
	LINKER_API bool getLinkerState(uint8 *pLinkerState);		

	LINKER_API bool resetLinker();
	LINKER_API bool factoryReset(LINKER_FACTRESET level);

	LINKER_API bool LeaveDeviceOpen();		// Convenience function. A slightly faster method. USB bus kept open until DeviceClose. MUST close USB at program END. 
											// If not used, each function will open/close the USB automatically.
	LINKER_API bool DeviceClose();			// only needed if LeaveDeviceOpen() called earlier.
	
#endif /*__LINKERAPI_H__*/